﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using System.Globalization;


namespace test
{
    public partial class frmInstersection : Form
    {
        public frmInstersection()
        {
            InitializeComponent();
        }
        ManagedProj4Projection proj4 = new ManagedProj4Projection();
        private void frmInstersection_Load(object sender, EventArgs e)
        {
            
            LoadDefaultMap();
            PlotPolygon();
            
        }
        private void LoadDefaultMap()
        {
            wfMap.MapUnit = GeographyUnit.Meter;
            proj4.InternalProjectionParametersString = ManagedProj4Projection.GetEpsgParametersString(4326);
            proj4.ExternalProjectionParametersString = ManagedProj4Projection.GetEsriParametersString(102018);

            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(Application.StartupPath + @"\Data\Countries02.shp");
            worldLayer.FeatureSource.Projection = proj4;
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            LayerOverlay coverlay = new LayerOverlay();
            coverlay.Layers.Add("WorldLayer", worldLayer);
            wfMap.Overlays.Add(coverlay);
            wfMap.Refresh();
        }
        
        private void PlotPolygon()
        {
            InMemoryFeatureLayer imCircle = new InMemoryFeatureLayer();
            imCircle.FeatureSource.Projection = proj4;
            imCircle.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = new PointStyle(PointSymbolType.Circle, new GeoSolidBrush(GeoColor.SimpleColors.Black), 2);
            imCircle.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new AreaStyle(new GeoPen(GeoColor.SimpleColors.Black, 2), new GeoSolidBrush(GeoColor.StandardColors.Transparent));
            imCircle.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            InMemoryFeatureLayer imCircle1 = new InMemoryFeatureLayer();
            imCircle1.FeatureSource.Projection = proj4;
            imCircle1.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = new PointStyle(PointSymbolType.Cross, new GeoSolidBrush(GeoColor.SimpleColors.Red), 10);
            imCircle1.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new AreaStyle(new GeoPen(GeoColor.SimpleColors.Red, 2), new GeoSolidBrush(GeoColor.StandardColors.Transparent));
            imCircle1.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay l = new LayerOverlay();
            l.Layers.Add(imCircle);
            l.Layers.Add(imCircle1);
            wfMap.Overlays.Add(l);

            Feature f1 = new Feature("POLYGON((-64.3822615417018 84.9251917212232,-60.34681717817 84.8780636193061,-56.4193189030956 84.8004790858569,-52.6443374260456 84.6937932053582,-49.0569111250176 84.5597441290979,-45.6817354777785 84.4003295405981,-42.5335357754621 84.2176859320018,-39.6182767677458 84.0139836432428,-36.9348155698754 83.7913445297803,-34.4766615164612 83.5517837307692,-32.2336117255855 83.2971733235264,-30.1931375219356 83.0292237766477,-28.3414797166331 82.7494786422336,-26.6644637186677 82.4593183090252,-25.1480727420078 82.1599694079045,-23.7788267528202 81.8525173106815,-22.5440136531981 81.5379199274882,-21.4318129831611 81.2170216229448,-20.4313445774736 80.8905665299498,-19.5326670015959 80.5592108629148,-18.7267440431564 80.2235340485053,-18.0053922875532 79.8840486295897,-17.361218794424 79.5412089806109,-16.787554928361 79.1954189179805,-16.278390266754 78.8470383104165,-15.8283090108568 78.4963888004951,-15.4324302970493 78.1437587461977,-15.0863531133191 77.789407483916,-14.786106072627 77.4335690047706,-14.5281020074579 77.0764551257592,-14.3090971762042 76.7182582270914,-14.1261547749369 76.3591536175766,-13.9766124015969 75.9993015813442,-13.8580531056987 75.6388491515703,-13.7682796629788 75.277931650243,-13.7052917327497 74.916674027259,-13.6672655805188 74.5551920272159,-13.6525360760991 74.1935932080603,-13.6595807056992 73.8319778321694,-13.68700536392 73.4704396474072,-13.7335317174115 73.109066573114,-13.7979859557362 72.7479413038072,-13.8792887665701 72.387141841519,-13.9764463917661 72.0267419661254,-14.088542638071 71.6668116516925,-14.2147317315888 71.3074174357334,-14.3542319185738 70.9486227473099,-14.5063197270027 70.5904881990945,-14.6703248137833 70.2330718478105,-14.8456253315738 69.876429426875,-15.0316437571671 69.5206145545579,-15.2278431303721 69.165678920537,-15.4337236584251 68.8116724533529,-15.6488196463014 68.4586434709475,-15.8726967179659 68.1066388161928,-16.1049492976819 67.7557039790779,-16.3451983240799 67.4058832070157,-16.5930891728184 67.0572196045531,-16.84828976642 66.7097552236123,-17.1104888522797 66.3635311452585,-17.3793944319627 66.0185875538694,-17.6547323267745 65.6749638044834,-17.9362448662313 65.3326984840115,-18.2236896875048 64.9918294669215,-18.5168386351951 64.6523939659346,-18.815476751916 64.3144285782148,-19.1194013511759 63.9779693274789,-19.4284211649227 63.6430517024086,-19.7423555589065 63.3097106917054,-20.0610338097115 62.9779808160927,-20.384294437928 62.6478961575391,-20.7119845924851 62.3194903859468,-21.0439594816602 61.9927967835246,-21.3800818467145 61.6678482670449,-21.7202214744999 61.3446774081605,-22.0642547457298 61.023316451943,-22.4120642159199 60.7037973337874,-22.7635382262882 60.3861516948134,-23.1185705421513 60.0704108958821,-23.477060016584 59.7566060303353,-23.8389102773118 59.4447679355549,-24.2040294349855 59.1349272034297,-24.572329811158 58.8271141898115,-24.9437276844274 58.5213590230328,-25.318143053346 58.2176916115521,-25.6954994148185 57.9161416507887,-26.0757235568184 57.6167386292021,-26.4587453643544 57.3195118336664,-26.8444976377088 57.0244903541864,-27.2329159220478 56.731703087999,-27.623938347583 56.4411787430973,-28.0175054795275 56.1529458412149,-28.4135601771529 55.8670327203025,-28.8120474613083 55.5834675365286,-29.212914389815 55.302278265831,-29.6161099401955 55.0234927050462,-30.0215848992394 54.747138472641,-30.4292917589451 54.4732430090675,-30.8391846184159 54.2018335767643,-31.2512190913166 53.9329372598208,-31.6653522185301 53.6665809633256,-32.0815423856797 53.4027914124134,-32.4997492452064 53.1415951510272,-32.9199336427166 52.8830185404112,-33.3420575473329 52.6270877573476,-33.7660839858031 52.373828792151,-34.1919769801388 52.1232674464321,-34.6197014885722 51.8754293306437,-35.0492233496336 51.6303398614185,-35.4805092291683 51.3880242587119,-35.9135265701209 51.1485075427565,-36.348243544932 50.9118145308416,-36.7846290103966 50.6779698339242,-37.2226524648505 50.4469978530826,-37.6622840075556 50.2189227758192,-38.1034943001644 49.993768572223,-38.5462545301547 49.7715589909978,-38.9905363761295 49.5523175553657,-39.4363119748855 49.3360675588521,-39.8835538901608 49.1228320609612,-40.3322350829756 48.9126338827476,-40.7823288834891 48.7054956022921,-41.2338089642966 48.5014395500889,-41.6866493150987 48.3004878043502,-42.1408242186771 48.102662186236,-42.5963082281165 47.9079842550147,-43.0530761452146 47.7164753031617,-43.5111030000284 47.528156351403,-43.9703640315029 47.3430481437091,-44.4308346691391 47.1611711422459,-44.8924905156519 46.9825455222901,-45.3553073305802 46.8071911671136,-45.8192610148054 46.6351276628445,-46.2843275959438 46.46637429331,-46.7504832145757 46.3009500348679,-47.2177041112777 46.1388735512329,-47.6859666144272 45.9801631883028,-48.1552471287476 45.8248369689918,-48.6255221245669 45.6729125880765,-49.0967681277604 45.5244074070602,-49.5689617103539 45.3793384490616,-50.0420794817601 45.2377223937344,-50.5160980806263 45.0995755722222,-50.990994167269 44.9649139621561,-51.466744416675 44.8337531826996,-51.9433255120473 44.706108489647,-52.4207141388755 44.5819947705806,-52.8988869795113 44.4614265400925,-53.3778207082308 44.3444179350763,-53.8574919867641 44.2309827100945,-54.3378774602766 44.1211342328259,-54.818953753782 44.0148854795998,-55.3006974689733 43.9122490310208,-55.7830851814534 43.8132370676898,-56.2660934383501 43.7178613660267,-56.7496987562996 43.6261332941981,-57.2338776197842 43.5380638081569,-57.7186064798076 43.4536634477963,-58.2038617528948 43.3729423332244,-58.6896198204004 43.2959101611627,-59.175857028112 43.2225762014734,-59.6625496861343 43.1529492938189,-60.1496740690401 43.0870378444581,-60.6372064162737 43.0248498231836,-61.1251229327933 42.9663927604019,-61.6133997899386 42.9116737443617,-62.1020131265109 42.8606994185335,-62.5909390500507 42.8134759791419,-63.0801536383005 42.770009172856,-63.5696329408386 42.7303042946393,-64.0593529808719 42.6943661857609,-64.5492897571731 42.6621992319731,-65.039419246149 42.6338073618542,-65.529717404028 42.6091940453214,-66.0201601691527 42.588362292314,-66.5107234643636 42.5713146516488,-67.0013831994631 42.5580532100493,-67.4921152737439 42.5485795913499,-67.9828955785704 42.5428949558759,-68.4737 42.541,-68.9645044214295 42.5428949558759,-69.4552847262561 42.5485795913499,-69.9460168005369 42.5580532100493,-70.4366765356364 42.5713146516488,-70.9272398308473 42.588362292314,-71.417682595972 42.6091940453214,-71.907980753851 42.6338073618542,-72.3981102428269 42.6621992319731,-72.8880470191281 42.6943661857609,-73.3777670591614 42.7303042946393,-73.8672463616995 42.770009172856,-74.3564609499493 42.8134759791418,-74.8453868734891 42.8606994185335,-75.3340002100614 42.9116737443617,-75.8222770672067 42.9663927604019,-76.3101935837262 43.0248498231836,-76.7977259309599 43.0870378444581,-77.2848503138657 43.1529492938188,-77.771542971888 43.2225762014734,-78.2577801795995 43.2959101611627,-78.7435382471051 43.3729423332244,-79.2287935201924 43.4536634477962,-79.7135223802158 43.5380638081569,-80.1977012437004 43.6261332941981,-80.6813065616499 43.7178613660267,-81.1643148185466 43.8132370676898,-81.6467025310267 43.9122490310207,-82.128446246218 44.0148854795998,-82.6095225397234 44.1211342328259,-83.0899080132358 44.2309827100945,-83.5695792917692 44.3444179350763,-84.0485130204886 44.4614265400924,-84.5266858611245 44.5819947705805,-85.0040744879527 44.7061084896469,-85.480655583325 44.8337531826995,-85.956405832731 44.964913962156,-86.4313019193736 45.0995755722222,-86.9053205182398 45.2377223937344,-87.3784382896461 45.3793384490616,-87.8506318722396 45.5244074070601,-88.3218778754331 45.6729125880765,-88.7921528712523 45.8248369689918,-89.2614333855728 45.9801631883028,-89.7296958887222 46.1388735512329,-90.1969167854242 46.3009500348679,-90.6630724040561 46.4663742933099,-91.1281389851946 46.6351276628444,-91.5920926694198 46.8071911671135,-92.054909484348 46.98254552229,-92.5165653308609 47.1611711422458,-92.977035968497 47.343048143709,-93.4362969999716 47.528156351403,-93.8943238547853 47.7164753031616,-94.3510917718835 47.9079842550146,-94.8065757813228 48.1026621862359,-95.2607506849012 48.3004878043501,-95.7135910357033 48.5014395500888,-96.1650711165108 48.705495602292,-96.6151649170243 48.9126338827475,-97.0638461098391 49.1228320609612,-97.5110880251144 49.336067558852,-97.9568636238704 49.5523175553656,-98.4011454698452 49.7715589909978,-98.8439056998355 49.9937685722229,-99.2851159924443 50.2189227758191,-99.7247475351493 50.4469978530825,-100.162770989603 50.6779698339241,-100.599156455068 50.9118145308415,-101.033873429879 51.1485075427564,-101.466890770832 51.3880242587118,-101.898176650366 51.6303398614185,-102.327698511428 51.8754293306435,-102.755423019861 52.123267446432,-103.181316014197 52.3738287921509,-103.605342452667 52.6270877573475,-104.027466357283 52.8830185404111,-104.447650754794 53.1415951510271,-104.86585761432 53.4027914124133,-105.28204778147 53.6665809633256,-105.696180908683 53.9329372598207,-106.108215381584 54.2018335767641,-106.518108241055 54.4732430090674,-106.92581510076 54.7471384726409,-107.331290059804 55.0234927050461,-107.734485610185 55.3022782658309,-108.135352538692 55.5834675365285,-108.533839822847 55.8670327203024,-108.929894520472 56.1529458412147,-109.323461652417 56.4411787430972,-109.714484077952 56.7317030879989,-110.102902362291 57.0244903541863,-110.488654635645 57.3195118336663,-110.871676443182 57.616738629202,-111.251900585181 57.9161416507886,-111.629256946654 58.217691611552,-112.003672315572 58.5213590230327,-112.375070188842 58.8271141898114,-112.743370565014 59.1349272034296,-113.108489722688 59.4447679355548,-113.470339983416 59.7566060303352,-113.828829457849 60.0704108958819,-114.183861773712 60.3861516948132,-114.53533578408 60.7037973337873,-114.88314525427 61.0233164519429,-115.2271785255 61.3446774081604,-115.567318153285 61.6678482670448,-115.90344051834 61.9927967835245,-116.235415407515 62.3194903859466,-116.563105562072 62.647896157539,-116.886366190288 62.9779808160926,-117.205044441093 63.3097106917053,-117.518978835077 63.6430517024085,-117.827998648824 63.9779693274788,-118.131923248084 64.3144285782147,-118.430561364805 64.6523939659345,-118.723710312495 64.9918294669214,-119.011155133768 65.3326984840113,-119.292667673225 65.6749638044832,-119.568005568037 66.0185875538692,-119.83691114772 66.3635311452584,-120.09911023358 66.7097552236122,-120.354310827181 67.0572196045529,-120.60220167592 67.4058832070155,-120.842450702318 67.7557039790777,-121.074703282034 68.1066388161926,-121.298580353698 68.4586434709474,-121.513676341575 68.8116724533528,-121.719556869628 69.1656789205369,-121.915756242833 69.5206145545578,-122.101774668426 69.8764294268749,-122.277075186216 70.2330718478104,-122.441080272997 70.5904881990943,-122.593168081426 70.9486227473097,-122.732668268411 71.3074174357332,-122.858857361929 71.6668116516924,-122.970953608234 72.0267419661253,-123.06811123343 72.3871418415189,-123.149414044264 72.7479413038071,-123.213868282588 73.1090665731139,-123.26039463608 73.4704396474071,-123.287819294301 73.8319778321693,-123.294863923901 74.1935932080601,-123.280134419481 74.5551920272158,-123.24210826725 74.9166740272589,-123.179120337021 75.2779316502429,-123.089346894301 75.6388491515702,-122.970787598403 75.9993015813441,-122.821245225063 76.3591536175765,-122.638302823795 76.7182582270912,-122.419297992542 77.076455125759,-122.161293927373 77.4335690047705,-121.861046886681 77.7894074839159,-121.51496970295 78.1437587461976,-121.119090989143 78.496388800495,-120.669009733246 78.8470383104164,-120.159845071639 79.1954189179803,-119.586181205576 79.5412089806108,-118.942007712447 79.8840486295896,-118.220655956843 80.2235340485052,-117.414732998404 80.5592108629147,-116.516055422526 80.8905665299497,-115.515587016839 81.2170216229447,-114.403386346802 81.537919927488,-113.16857324718 81.8525173106814,-111.799327257992 82.1599694079044,-110.282936281332 82.4593183090251,-108.605920283367 82.7494786422334,-106.754262478064 83.0292237766476,-104.713788274414 83.2971733235263,-102.470738483539 83.551783730769,-100.012584430124 83.7913445297802,-97.3291232322542 84.0139836432427,-94.4138642245379 84.2176859320018,-91.2656645222216 84.400329540598,-87.8904888749824 84.5597441290978,-84.3030625739544 84.6937932053582,-80.5280810969043 84.8004790858569,-76.6005828218299 84.8780636193061,-72.5651384582982 84.9251917212232,-68.4737000000007 84.9409999999999,-64.3822615417018 84.9251917212232))");
            Feature f2 = new Feature("POLYGON((-169.807934243922 88.5801325682512,177.018327491818 88.4560008688564,166.157556115418 88.2688133980428,157.533901928494 88.0365640166594,150.733202479475 87.7733600713438,145.317136865707 87.488975162378,140.929962003563 87.1898965014553,137.307895906739 86.8804154870402,134.260938602002 86.5634126867865,131.652662092333 86.2408644650871,129.384290159259 85.9141599357856,127.383361269352 85.5842992437069,125.595921873503 85.2520192633736,123.981188420765 84.9178747930119,122.507879590657 84.5822920914704,121.151669807464 84.245604915046,119.893398383567 83.9080792614433,118.717792655333 83.5699306809914,117.612544943201 83.2313366012288,116.567636266682 82.8924452445514,115.574834440692 82.553382178074,114.627317026287 82.2142551914114,113.719384810371 81.8751579759753,112.846241722202 81.5361729332717,112.003824067496 81.1973733419949,111.188666770616 80.8588250473954,110.397797672891 80.5205877907245,109.628653306169 80.1827162646693,108.879011254111 79.845260958145,108.146935435947 79.5082688376752,107.430731538681 79.1717839009166,106.728910479977 78.8358476293407,106.040158271603 78.50049936078,105.363311018853 78.1657765978371,104.697334067711 77.8317152646209,104.04130452203 77.4983499215842,103.394396514625 77.1657139461856,102.755868741091 76.833839685518,102.125053862458 76.5027585858155,101.501349458935 76.1725013027932,100.884210277102 75.8430977960215,100.273141560512 75.5145774099365,99.6676932916453 75.1869689436185,99.067455203616 74.8603007110864,98.4720524445404 74.5346005935533,97.8811417973686 74.2098960848412,97.2944083741231 73.8862143309513,96.711562716705 73.5635821646238,96.1323382472663 73.2420261355873,95.5564890200821 72.9215725370855,94.983787734248 72.6022474291814,94.4140239726683 72.2840766592595,93.8470026379191 71.967085880086,93.2825425598533 71.6513005657341,92.7204752534095 71.3367460256365,92.1606438081115 71.0234474169905,91.6029018933082 70.7114297557107,91.0471128653638 70.4007179260949,90.4931489648591 70.0913366893507,89.9408905934277 69.7833106911064,89.3902256611957 69.4766644680166,88.8410489969457 69.1714224535584,88.2932618141102 68.8676089830999,87.7467712265524 68.5652482983159,87.2014898088282 68.2643645510134,86.6573351962569 67.9649818064234,86.1142297206806 67.6671240460093,85.5721000782728 67.3708151698352,85.0308770261714 67.0760789985322,84.4904951050789 66.7829392748988,83.9508923852897 66.4914196651632,83.4120102338838 66.2015437599375,82.8737931010717 65.9133350748856,82.3361883238908 65.6268170511277,81.7991459456458 65.3420130554004,81.2626185496486 65.058946379989,80.7265611059668 64.7776402424486,80.190930830018 64.4981177851269,79.6556870519655 64.2204020745026,79.1207910959721 63.9445161003489,78.5862061684646 63.6704827747343,78.0518972546397 63.3983249308683,77.5178310225176 63.1280653218023,76.9839757339165 62.8597266189919,76.4503011617739 62.5933314107278,75.9167785133009 62.3289022004433,75.3833803584976 62.0664614049024,74.8500805636004 61.8060313522751,74.3168542290726 61.5476342801045,73.7836776317825 61.2912923331714,73.2505281710419 61.0370275612588,72.7173843182112 60.7848619168229,72.1842255695973 60.534817252572,71.6510324023949 60.2869153189591,71.1177862334454 60.0411777615899,70.5844693806011 59.7976261185505,70.0510650265039 59.5562818176574,69.5175571846012 59.3171661736335,68.9839306672352 59.0803003852116,68.450171055657 58.8457055321695,67.9162646718251 58.6134025722991,67.3821985518629 58.3834123383111,66.8479604210539 58.1557555346796,66.3135386702687 57.9304527344273,65.7789223337205 57.7075243758554,65.2441010679567 57.4869907592189,64.7090651319987 57.2688720433518,64.1738053685508 57.0531882422424,63.6383131862024 56.8399592215631,63.1025805425537 56.6292046951553,62.5665999282023 56.4209442214729,62.030364351528 56.2151971999869,61.4938673242218 56.0119828675527,60.9571028475057 55.8113202947426,60.4200653989955 55.6132283821472,59.8827499201608 55.4177258566459,59.3451518043399 55.2248312676513,58.8072668852703 55.0345629833285,58.2690914260966 54.8469391867915,57.7306221088232 54.6619778722815,57.1918560241777 54.4796968413265,56.6527906618557 54.3001136988869,56.1134239011179 54.1232458494898,55.5737540017134 53.9491104933526,55.0337795951045 53.7777246225012,54.4934996759685 53.6091050168835,53.9529135939561 53.4432682404813,53.4120210456855 53.2802306374246,52.8708220669511 53.120008328109,52.329317025132 52.9626172053204,51.7875066117808 52.8080729303693,51.2453918353776 52.6563909292378,50.7029740142347 52.5075863887415,50.1602547695376 52.3616742527098,49.617236018509 52.2186692181866,49.0739199676851 52.0785857316558,48.5303091062895 51.941437985292,47.9864061996986 51.8072399132422,47.4422142829834 51.6760051879389,46.8977366545229 51.5477472164483,46.352976869677 51.4224791368576,45.8079387345128 51.3002138147018,45.2626262995759 51.1809638394355,44.7170438537001 51.0647415209508,44.1711959178477 50.9515588861443,43.625087238977 50.8414276755368,43.0787227839289 50.7343593399478,42.5321077333281 50.6303650372277,41.9852474754957 50.5294556290507,41.438147600367 50.4316416777699,40.8908138934113 50.3369334433402,40.3432523295511 50.245340880307,39.7954690670756 50.1568736348683,39.2474704415475 50.0715410420085,38.6992629596997 49.9893521227099,38.1508532933196 49.9103155812408,37.6022482731193 49.834439802526,37.0534548825904 49.7617328495998,36.5044802518409 49.692202461144,35.9553316514152 49.6258560491147,35.406016486093 49.5627006964571,34.8565422886705 49.5027431549139,34.3069167137192 49.4459898429261,33.7571475313266 49.3924468436302,33.2072426208138 49.3421199029526,32.6572099644349 49.2950144278032,32.1070576410551 49.25113548437,31.5567938198096 49.2104877965166,31.0064267537434 49.1730757442824,30.455964773433 49.1389033624898,29.9054162805908 49.1079743394567,29.3547897416532 49.0802920158171,28.8040936813534 49.0558593834515,28.2533366762807 49.0346790845262,27.702527348427 49.0167534106437,27.1516743587215 49.0020843021051,26.6007864005567 48.9906733472848,26.0498721933059 48.9825217821172,25.4989404758332 48.9776304896984,24.948 48.976,24.3970595241668 48.9776304896984,23.8461278066941 48.9825217821172,23.2952135994433 48.9906733472848,22.7443256412786 49.0020843021051,22.193472651573 49.0167534106437,21.6426633237192 49.0346790845262,21.0919063186466 49.0558593834515,20.5412102583468 49.0802920158171,19.9905837194092 49.1079743394567,19.440035226567 49.1389033624898,18.8895732462566 49.1730757442824,18.3392061801904 49.2104877965165,17.7889423589449 49.25113548437,17.2387900355652 49.2950144278031,16.6887573791863 49.3421199029526,16.1388524686735 49.3924468436302,15.5890832862807 49.4459898429261,15.0394577113295 49.5027431549139,14.489983513907 49.5627006964571,13.9406683485848 49.6258560491146,13.3915197481591 49.692202461144,12.8425451174097 49.7617328495997,12.2937517268807 49.834439802526,11.7451467066804 49.9103155812407,11.1967370403003 49.9893521227099,10.6485295584525 50.0715410420085,10.1005309329244 50.1568736348682,9.55274767044891 50.245340880307,9.00518610658871 50.3369334433402,8.45785239963305 50.4316416777699,7.91075252450433 50.5294556290506,7.36389226667196 50.6303650372277,6.81727721607115 50.7343593399478,6.27091276102299 50.8414276755367,5.72480408215235 50.9515588861442,5.17895614629998 51.0647415209508,4.63337370042409 51.1809638394355,4.08806126548728 51.3002138147017,3.54302313032308 51.4224791368575,2.99826334547711 51.5477472164483,2.45378571701662 51.6760051879388,1.90959380030145 51.8072399132422,1.36569089371052 51.9414379852919,0.822080032315002 52.0785857316557,0.27876398149101 52.2186692181866,-0.264254769537506 52.3616742527097,-0.806974014234657 52.5075863887415,-1.34939183537755 52.6563909292377,-1.89150661178075 52.8080729303692,-2.43331702513192 52.9626172053203,-2.97482206695101 53.120008328109,-3.51602104568542 53.2802306374246,-4.05691359395608 53.4432682404812,-4.59749967596838 53.6091050168834,-5.13777959510441 53.7777246225011,-5.67775400171333 53.9491104933525,-6.21742390111782 54.1232458494897,-6.75679066185559 54.3001136988869,-7.29585602417757 54.4796968413264,-7.83462210882307 54.6619778722815,-8.37309142609652 54.8469391867915,-8.91126688527023 55.0345629833284,-9.44915180433987 55.2248312676513,-9.98674992016062 55.4177258566458,-10.5240653989953 55.6132283821471,-11.0611028475056 55.8113202947426,-11.5978673242217 56.0119828675526,-12.1343643515279 56.2151971999868,-12.6705999282021 56.4209442214728,-13.2065805425535 56.6292046951552,-13.7423131862022 56.8399592215631,-14.2778053685507 57.0531882422423,-14.8130651319985 57.2688720433517,-15.3481010679565 57.4869907592188,-15.8829223337204 57.7075243758553,-16.4175386702685 57.9304527344272,-16.9519604210538 58.1557555346795,-17.4861985518628 58.383412338311,-18.020264671825 58.613402572299,-18.5541710556568 58.8457055321694,-19.087930667235 59.0803003852115,-19.6215571846011 59.3171661736334,-20.1550650265038 59.5562818176573,-20.6884693806009 59.7976261185504,-21.2217862334452 60.0411777615898,-21.7550324023947 60.286915318959,-22.2882255695971 60.5348172525719,-22.821384318211 60.7848619168228,-23.3545281710417 61.0370275612587,-23.8876776317823 61.2912923331713,-24.4208542290725 61.5476342801044,-24.9540805636001 61.806031352275,-25.4873803584974 62.0664614049023,-26.0207785133007 62.3289022004432,-26.5543011617736 62.5933314107277,-27.0879757339163 62.8597266189918,-27.6218310225174 63.1280653218022,-28.1558972546394 63.3983249308682,-28.6902061684644 63.6704827747342,-29.2247910959719 63.9445161003488,-29.7596870519652 64.2204020745025,-30.2949308300178 64.4981177851268,-30.8305611059665 64.7776402424485,-31.3666185496484 65.0589463799889,-31.9031459456456 65.3420130554003,-32.4401883238906 65.6268170511276,-32.9777931010714 65.9133350748855,-33.5160102338836 66.2015437599374,-34.0548923852894 66.4914196651631,-34.5944951050786 66.7829392748987,-35.1348770261711 67.0760789985321,-35.6761000782725 67.370815169835,-36.2182297206803 67.6671240460092,-36.7613351962567 67.9649818064233,-37.3054898088279 68.2643645510133,-37.8507712265521 68.5652482983158,-38.3972618141098 68.8676089830998,-38.9450489969454 69.1714224535583,-39.4942256611954 69.4766644680165,-40.0448905934274 69.7833106911063,-40.5971489648588 70.0913366893506,-41.1511128653635 70.4007179260948,-41.7069018933078 70.7114297557105,-42.2646438081113 71.0234474169904,-42.8244752534091 71.3367460256363,-43.386542559853 71.651300565734,-43.9510026379187 71.9670858800859,-44.5180239726681 72.2840766592594,-45.0877877342478 72.6022474291813,-45.6604890200818 72.9215725370853,-46.2363382472661 73.2420261355872,-46.8155627167048 73.5635821646237,-47.3984083741228 73.8862143309511,-47.9851417973683 74.2098960848411,-48.5760524445401 74.5346005935532,-49.1714552036157 74.8603007110863,-49.771693291645 75.1869689436184,-50.3771415605113 75.5145774099364,-50.9882102771017 75.8430977960214,-51.6053494589347 76.1725013027931,-52.2290538624577 76.5027585858153,-52.8598687410908 76.8338396855179,-53.4983965146247 77.1657139461854,-54.1453045220302 77.4983499215841,-54.8013340677104 77.8317152646208,-55.4673110188525 78.1657765978369,-56.1441582716024 78.5004993607798,-56.8329104799766 78.8358476293406,-57.5347315386807 79.1717839009165,-58.2509354359471 79.5082688376751,-58.9830112541105 79.8452609581448,-59.7326533061682 80.1827162646692,-60.5017976728909 80.5205877907244,-61.2926667706161 80.8588250473953,-62.1078240674953 81.1973733419948,-62.950241722202 81.5361729332716,-63.8233848103706 81.8751579759752,-64.7313170262869 82.2142551914113,-65.6788344406921 82.5533821780739,-66.6716362666814 82.8924452445513,-67.7165449432004 83.2313366012287,-68.821792655333 83.5699306809913,-69.997398383566 83.9080792614431,-71.2556698074634 84.2456049150459,-72.6118795906569 84.5822920914703,-74.0851884207649 84.9178747930118,-75.6999218735024 85.2520192633734,-77.4873612693523 85.5842992437068,-79.4882901592588 85.9141599357854,-81.7566620923325 86.240864465087,-84.3649386020019 86.5634126867864,-87.4118959067381 86.8804154870401,-91.033962003563 87.1898965014552,-95.4211368657066 87.4889751623778,-100.837202479475 87.7733600713436,-107.637901928494 88.0365640166592,-116.261556115418 88.2688133980426,-127.122327491818 88.4560008688561,-140.296065756077 88.580132568251,-155.051999999997 88.6240000000003,-169.807934243922 88.5801325682512))");
            Feature f3 = new Feature("POLYGON((132.8761015006 83.2793670494736,135.941043808962 83.2416130533205,138.95423989284 83.1791645749976,141.892620129824 83.0927068912883,144.736148638969 82.9831488221868,147.468350911027 82.8515794058479,150.07654059168 82.6992208621693,152.551774743429 82.5273819717017,154.888594676826 82.3374151498236,157.084621335763 82.1306793992826,159.140072519491 81.9085102324905,161.057258539626 81.6721967423759,162.840098138214 81.4229653471409,164.493681493488 81.1619693436338,166.023894275159 80.8902832335743,167.437106981196 80.6089007755136,168.739927239246 80.3187358032378,169.939008911927 80.0206249895234,171.040910040143 79.715331888104,172.051991240564 79.403551734792,172.978346603267 79.0859166194314,173.825760013517 78.7630007492244,174.599680877321 78.4353256107343,175.305214295985 78.1033649045956,175.947121717563 77.7675491767094,176.529828949517 77.4282701057085,177.057439135008 77.0858844317587,177.53374888044 76.7407175288946,177.962266188235 76.3930666341909,178.346229214009 76.0432037538038,178.688625148763 75.6913782695608,178.992208740849 75.3378192712915,179.259520133169 74.9827376401795,179.492901810218 74.6263279075843,179.694514536583 74.2687699124033,179.86635223116 73.9102302783528,-179.989744234496 73.5508637307355,-179.872074294898 73.1908142704257,-179.779065967472 72.8302162210277,-179.709265095867 72.4691951634847,-179.661325500791 72.1078687708613,-179.633999976052 71.7463475546028,-179.626132066716 71.3847355322882,-179.636648567486 71.0231308257414,-179.66455268173 70.6616261973345,-179.708917784696 70.3003095314007,-179.768881738022 69.939264266866,-179.843641706361 69.5785697864889,-179.932449430741 69.2183017674699,179.965393083026 68.8585324976314,179.850537499035 68.4993311608827,179.723592743843 68.1407640952526,179.585128288536 67.7828950263922,179.435677149027 67.4257852791203,179.275738630631 67.0694939692889,179.105780840505 66.7140781779888,178.926242989295 66.3595931098895,178.73753750129 66.0060922373072,178.54005195055 65.6536274314195,178.334150838772 65.3022490818881,178.120177229166 64.952006206017,177.898454249239 64.6029465484501,177.669286474143 64.2551166723055,177.432961201141 63.9085620425503,177.189749624734 63.5633271023334,176.939907921103 63.2194553429232,176.683678249682 62.8769893678252,176.421289678962 62.5359709516023,176.152959042971 62.1964410938628,175.878891734257 61.8584400688378,175.599282438679 61.5220074709267,175.314315816832 61.1871822565541,175.024167136474 60.8540027826447,174.729002859952 60.5225068419986,174.42898119025 60.1927316958169,174.124252578968 59.8647141036092,173.814960199245 59.5384903506892,173.501240386386 59.2140962734477,173.183223048691 58.8915672825743,172.861032050801 58.570938384384,172.534785571643 58.2522442003901,172.204596438911 57.9355189852539,171.870572441834 57.6207966432281,171.532816623849 57.3081107432029,171.191427556657 56.9974945324529,170.846499597019 56.6889809491751,170.498123127546 56.3826026339007,170.146384782619 56.0783919398569,169.791367660508 55.7763809423479,169.43315152264 55.4766014472195,169.071812980935 55.1790849984655,168.707425674016 54.8838628850313,168.340060433056 54.5909661468634,167.969785437969 54.300425580252,167.596666364587 54.0122717425085,167.220766523426 53.7265349560184,166.842146990586 53.443245311705,166.460866731309 53.1624326719389,166.076982716652 52.884126672924,165.690550033735 52.6083567265902,165.30162198995 52.335152022019,164.910250211519 52.0645415264292,164.516484736751 51.7965539857441,164.120374104318 51.5312179247657,163.721965436852 51.2685616469733,163.321304520151 51.0086132339696,162.918435878238 50.7514005445903,162.513402844542 50.4969512136959,162.106247629388 50.2452926506618,161.697011384052 49.9964520375831,161.285734261537 49.7504563272075,160.872455474271 49.5073322406115,160.457213348901 49.2671062646342,160.040045378331 49.0298046490785,159.620988271151 48.7954534036963,159.200077998613 48.5640782949655,158.77734983926 48.3357048426726,158.352838421348 48.1103583163117,157.926577763156 47.8880637313091,157.498601311313 47.668845845085,157.068941977218 47.4527291529622,156.637632171658 47.2397378839305,156.204703837712 47.0298959962775,155.770188482017 46.823227173094,155.334117204476 46.6197548176633,154.896520726475 46.4195020487436,154.457429417692 46.222491695751,154.016873321537 46.0287462938534,153.574882179302 45.8382880789817,153.131485453077 45.6511389827673,152.686712347471 45.4673206274151,152.240591830201 45.2868543205178,151.793152651595 45.1097610498206,151.344423363044 44.9360614779451,150.894432334464 44.7657759370777,150.443207770782 44.5989244236321,149.990777727511 44.4355265928924,149.537170125435 44.2756017536453,149.082412764436 44.1191688628074,148.626533336508 43.9662465200557,148.169559437978 43.8168529624693,147.71151858097 43.6710060591874,147.252438204139 43.5287233060934,146.792345682699 43.3900218205293,146.331268337777 43.2549183360498,145.869233445115 43.1234291972216,145.406268243141 42.9955703544747,144.942399940443 42.8713573590132,144.477655722653 42.7508053577913,144.012062758778 42.6339290885617,143.545648206987 42.5207428750026,143.078439219886 42.4112606219289,142.610462949287 42.3054958105953,142.141746550511 42.2034614940958,141.672317186216 42.1051702928666,141.202202029796 42.0106343902974,140.731428268355 41.9198655284582,140.260023105277 41.8328750039444,139.788013762402 41.7496736638494,139.315427481845 41.6702719018661,138.842291527454 41.594679654525,138.368633185935 41.5229063975727,137.894479767661 41.454961142496,137.419858607174 41.3908524331947,136.944797063408 41.3305883428103,136.46932251964 41.2741764707114,135.993462383183 41.2216239396427,135.517244084853 41.1729373930385,135.040695078209 41.1281229925076,134.563842838584 41.0871864154892,134.086714861938 41.0501328530857,133.609338663529 41.0169670080743,133.131741776431 40.9876930930995,132.653951749912 40.9623148290496,132.175996147681 40.9408354436192,131.697902546028 40.9232576700594,131.219698531877 40.9095837461175,130.741411700747 40.8998154131674,130.26306965466 40.8939539155323,129.7847 40.892,129.30633034534 40.8939539155323,128.827988299253 40.8998154131674,128.349701468123 40.9095837461175,127.871497453972 40.9232576700594,127.393403852319 40.9408354436192,126.915448250088 40.9623148290496,126.437658223569 40.9876930930995,125.960061336471 41.0169670080743,125.482685138062 41.0501328530857,125.005557161416 41.0871864154892,124.528704921791 41.1281229925076,124.052155915147 41.1729373930385,123.575937616817 41.2216239396426,123.10007748036 41.2741764707114,122.624602936592 41.3305883428103,122.149541392826 41.3908524331947,121.674920232339 41.4549611424959,121.200766814065 41.5229063975727,120.727108472546 41.5946796545249,120.253972518155 41.670271901866,119.781386237598 41.7496736638494,119.309376894723 41.8328750039444,118.837971731645 41.9198655284581,118.367197970204 42.0106343902974,117.897082813785 42.1051702928665,117.427653449489 42.2034614940958,116.958937050712 42.3054958105953,116.490960780114 42.4112606219289,116.023751793013 42.5207428750026,115.557337241222 42.6339290885617,115.091744277347 42.7508053577912,114.627000059557 42.8713573590131,114.163131756859 42.9955703544746,113.700166554885 43.1234291972215,113.238131662223 43.2549183360497,112.777054317301 43.3900218205292,112.316961795861 43.5287233060933,111.85788141903 43.6710060591874,111.399840562022 43.8168529624692,110.942866663492 43.9662465200557,110.486987235564 44.1191688628073,110.032229874565 44.2756017536453,109.578622272489 44.4355265928923,109.126192229218 44.598924423632,108.674967665536 44.7657759370776,108.224976636955 44.9360614779451,107.776247348405 45.1097610498205,107.328808169799 45.2868543205177,106.882687652529 45.4673206274151,106.437914546923 45.6511389827672,105.994517820698 45.8382880789816,105.552526678463 46.0287462938534,105.111970582308 46.2224916957509,104.672879273525 46.4195020487435,104.235282795524 46.6197548176632,103.799211517983 46.8232271730939,103.364696162288 47.0298959962774,102.931767828342 47.2397378839304,102.500458022782 47.4527291529621,102.070798688687 47.6688458450849,101.642822236844 47.888063731309,101.216561578652 48.1103583163117,100.79205016074 48.3357048426725,100.369322001387 48.5640782949654,99.9484117288494 48.7954534036963,99.5293546216694 49.0298046490784,99.1121866510986 49.2671062646341,98.6969445257291 49.5073322406114,98.2836657384631 49.7504563272074,97.8723886159476 49.9964520375831,97.4631523706121 50.2452926506617,97.0559971554586 50.4969512136958,96.6509641217616 50.7514005445902,96.2480954798495 51.0086132339695,95.8474345631478 51.2685616469732,95.4490258956822 51.5312179247656,95.052915263249 51.796553985744,94.6591497884813 52.0645415264291,94.2677780100505 52.3351520220189,93.8788499662653 52.6083567265901,93.4924172833483 52.8841266729239,93.1085332686914 53.1624326719388,92.7272530094137 53.4432453117049,92.3486334765742 53.7265349560183,91.9727336354131 54.0122717425084,91.5996145620315 54.3004255802519,91.2293395669442 54.5909661468633,90.861974325984 54.8838628850312,90.497587019065 55.1790849984654,90.1362484773603 55.4766014472194,89.7780323394921 55.7763809423478,89.4230152173806 56.0783919398568,89.0712768724545 56.3826026339006,88.7229004029814 56.688980949175,88.3779724433435 56.9974945324528,88.0365833761512 57.3081107432028,87.6988275581663 57.620796643228,87.3648035610893 57.9355189852538,87.0346144283571 58.25224420039,86.7083679491989 58.5709383843839,86.3861769513087 58.8915672825742,86.0681596136141 59.2140962734476,85.754439800755 59.5384903506891,85.4451474210325 59.8647141036091,85.1404188097502 60.1927316958168,84.8403971400483 60.5225068419985,84.5452328635263 60.8540027826446,84.2550841831681 61.1871822565539,83.9701175613209 61.5220074709266,83.6905082657431 61.8584400688376,83.4164409570291 62.1964410938627,83.1481103210385 62.5359709516022,82.8857217503184 62.8769893678251,82.6294920788969 63.219455342923,82.3796503752663 63.5633271023333,82.1364387988595 63.9085620425501,81.9001135258567 64.2551166723054,81.670945750761 64.6029465484499,81.4492227708343 64.9520062060168,81.2352491612284 65.3022490818879,81.02934804945 65.6536274314194,80.8318624987101 66.0060922373071,80.6431570107052 66.3595931098893,80.4636191594949 66.7140781779887,80.2936613693694 67.0694939692888,80.1337228509733 67.4257852791202,79.9842717114641 67.782895026392,79.8458072561571 68.1407640952525,79.7188625009652 68.4993311608826,79.6040069169743 68.8585324976312,79.5018494307414 69.2183017674698,79.4130417063612 69.5785697864888,79.3382817380225 69.9392642668658,79.2783177846962 70.3003095314006,79.2339526817297 70.6616261973343,79.206048567486 71.0231308257412,79.195532066716 71.384735532288,79.2033999760525 71.7463475546027,79.2307255007915 72.1078687708612,79.2786650958667 72.4691951634846,79.3484659674725 72.8302162210275,79.4414742948983 73.1908142704255,79.5591442344964 73.5508637307353,79.7030477688405 73.9102302783527,79.8748854634171 74.2687699124032,80.0764981897819 74.6263279075842,80.3098798668313 74.9827376401793,80.5771912591515 75.3378192712914,80.8807748512367 75.6913782695606,81.2231707859913 76.0432037538037,81.6071338117656 76.3930666341908,82.0356511195607 76.7407175288945,82.5119608649918 77.0858844317586,83.0395710504834 77.4282701057084,83.6222782824371 77.7675491767093,84.2641857040154 78.1033649045955,84.9697191226787 78.4353256107341,85.7436399864826 78.7630007492244,86.5910533967335 79.0859166194313,87.5174087594362 79.4035517347918,88.5284899598574 79.7153318881038,89.6303910880732 80.0206249895232,90.8294727607544 80.3187358032377,92.1322930188043 80.6089007755135,93.5455057248413 80.8902832335741,95.0757185065116 81.1619693436337,96.7293018617857 81.4229653471408,98.512141460374 81.6721967423759,100.429327480509 81.9085102324904,102.484778664237 82.1306793992825,104.680805323174 82.3374151498235,107.017625256571 82.5273819717017,109.49285940832 82.6992208621692,112.101049088973 82.8515794058479,114.833251361031 82.9831488221868,117.676779870176 83.0927068912883,120.61516010716 83.1791645749976,123.628356191038 83.2416130533204,126.6932984994 83.2793670494736,129.784699999999 83.292,132.8761015006 83.2793670494736))");

            imCircle.InternalFeatures.Add(f1);
            imCircle.InternalFeatures.Add(f2);
            imCircle.InternalFeatures.Add(f3);

            var Points = f1.GetShape().GetCrossing(f2.GetShape());
            foreach (var Points1 in Points.Points)
            {
                Feature fpoint = new Feature(Points1);
                imCircle1.InternalFeatures.Add(fpoint);
            }

            Points = f2.GetShape().GetCrossing(f3.GetShape());
            foreach (var Points1 in Points.Points)
            {
                Feature fpoint = new Feature(Points1);
                imCircle1.InternalFeatures.Add(fpoint);
            }


        }
        
      
        private void wfMap_MouseMove(object sender, MouseEventArgs e)
        {
            try
            {
                PointShape WorldPointR = ExtentHelper.ToWorldCoordinate(wfMap.CurrentExtent, e.X, e.Y, wfMap.Width, wfMap.Height);
                double X = e.X;
                double Y = e.Y;
                if (wfMap.MapUnit == GeographyUnit.Meter)
                {
                    Vertex v = new Vertex();
                    Feature fp = new Feature(WorldPointR);

                    //if (proj4.ConvertToExternalProjection(wfMap.FindFeatureLayer("CountryLayer").GetBoundingBox()).Contains(fp))
                    //if (WorldPointR.X < wfMap.CurrentExtent.UpperLeftPoint.X && WorldPointR.X > wfMap.CurrentExtent.LowerRightPoint.X && WorldPointR.Y < wfMap.CurrentExtent.UpperLeftPoint.Y && WorldPointR.Y > wfMap.CurrentExtent.LowerRightPoint.Y)
                    // {
                    v = proj4.ConvertToInternalProjection(Convert.ToDouble(WorldPointR.X), Convert.ToDouble(WorldPointR.Y));
                    statusStrip1.Items[1].Text = string.Format(CultureInfo.InvariantCulture, "Long: {0:F4} Lat: {1:F4}", v.X, v.Y);
                    // }
                }



                if (wfMap.MapUnit == GeographyUnit.DecimalDegree && ((WorldPointR.X > -180 && WorldPointR.X < 180 && WorldPointR.Y > -90 && WorldPointR.Y < 90)))
                {

                    statusStrip1.Items[0].Text = DecimalDegreesHelper.GetDegreesMinutesSecondsStringFromDecimalDegreePoint(WorldPointR);

                    return;
                }
                statusStrip1.Items[0].Text = "";
            }
            catch (Exception err)
            {
                statusStrip1.Items[1].Text = "";
                // MessageBox.Show(err.Message);
            }
            finally
            {

            }
        }
    }
}
